LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;

ENTITY comp IS
	PORT 
	(
		duty	: IN std_logic_vector (9 downto 0);
		cnter	: IN std_logic_vector (9 downto 0);
		clock	: IN std_logic;
		q		: BUFFER std_logic := '0'
	);
END comp;


ARCHITECTURE a_comp OF comp IS

BEGIN
	PROCESS
	BEGIN
		WAIT UNTIL clock'EVENT AND clock = '1';

		-- dc = 0 -> switch off permanent
		IF (duty = "0000000000") THEN
			q <= '0';
		ELSE
			-- dc = 1 -> switch on permanent
			IF (duty = "1111111111") THEN
				q <= '1';
			ELSE
				-- 0 < dc < 1023 deceide state
				IF duty >= cnter THEN
					q <= '1';
				ELSE
					q <= '0';
				END IF;
			
			END IF; -- dc == max
		END IF; -- dc == 0

	END PROCESS;

END a_comp;
