LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;

ENTITY counter IS
	PORT
	(
		clk_in : IN std_logic;
		clk_out: OUT std_logic;
		count  : BUFFER STD_LOGIC_VECTOR(9 DOWNTO 0)
	);
END counter;



ARCHITECTURE a_counter OF counter IS

-- we need an internal signals since count is an output, not a buffer
SIGNAL	clock2	: std_logic;
BEGIN

	PROCESS
		BEGIN
		WAIT UNTIL clk_in'EVENT AND clk_in = '1';
		clock2 <= NOT clock2;
		clk_out<= NOT clock2;
	END PROCESS;

	PROCESS
		BEGIN
		WAIT UNTIL clock2'EVENT AND clock2 = '1';
		count   <= count + 1;
	END PROCESS;

END a_counter;
